// <auto-generated/>
//-----------------------------------------------------------------------------
// <copyright file="SLUSBXpressDLL.cs" company="eQ-3 Entwicklung GmbH">
//  Copyright (c) 2013 eQ-3 Entwicklung GmbH
// </copyright>
// <summary>Utility-class for providing constants from SiUSBXp.dll.</summary>
//-----------------------------------------------------------------------------
namespace DDSCommunication.USB
{
    using System;
    using System.Collections.Generic;
    using System.Runtime.InteropServices;
    using System.Text;

    /// <summary>
    /// Utility-class for providing constants from SiUSBXp.dll.
    /// </summary>
    public class SLUSBXpressDLL
    {
        // Return Codes
        public const int SI_SUCCESS = 0x00;
        public const int SI_DEVICE_NOT_FOUND = 0xFF;
        public const int SI_INVALID_HANDLE = 0x01;
        public const int SI_READ_ERROR = 0x02;
        public const int SI_RX_QUEUE_NOT_READY = 0x03;
        public const int SI_WRITE_ERROR = 0x04;
        public const int SI_RESET_ERROR = 0x05;
        public const int SI_INVALID_PARAMETER = 0x06;
        public const int SI_INVALID_REQUEST_LENGTH = 0x07;
        public const int SI_DEVICE_IO_FAILED = 0x08;
        public const int SI_INVALID_BAUDRATE = 0x09;
        public const int SI_FUNCTION_NOT_SUPPORTED = 0x0a;
        public const int SI_GLOBAL_DATA_ERROR = 0x0b;
        public const int SI_SYSTEM_ERROR_CODE = 0x0c;
        public const int SI_READ_TIMED_OUT = 0x0d;
        public const int SI_WRITE_TIMED_OUT = 0x0e;
        public const int SI_IO_PENDING = 0x0f;

        // GetProductString() function flags
        public const int SI_RETURN_SERIAL_NUMBER = 0x00;
        public const int SI_RETURN_DESCRIPTION = 0x01;
        public const int SI_RETURN_LINK_NAME = 0x02;
        public const int SI_RETURN_VID = 0x03;
        public const int SI_RETURN_PID = 0x04;

        // RX Queue status flags
        public const int SI_RX_NO_OVERRUN = 0x00;
        public const int SI_RX_EMPTY = 0x00;
        public const int SI_RX_OVERRUN = 0x01;
        public const int SI_RX_READY = 0x02;

        // Buffer size limits
        public const int SI_MAX_DEVICE_STRLEN = 256;
        public const int SI_MAX_READ_SIZE = 4096 * 1;
        public const int SI_MAX_WRITE_SIZE = 4096;

        // Input and Output pin Characteristics
        public const int SI_HELD_INACTIVE = 0x00;
        public const int SI_HELD_ACTIVE = 0x01;
        public const int SI_FIRMWARE_CONTROLLED = 0x02;
        public const int SI_RECEIVE_FLOW_CONTROL = 0x02;
        public const int SI_TRANSMIT_ACTIVE_SIGNAL = 0x03;
        public const int SI_STATUS_INPUT = 0x00;
        public const int SI_HANDSHAKE_LINE = 0x01;

        // Mask and Latch value bit definitions
        public const int SI_GPIO_0 = 0x01;
        public const int SI_GPIO_1 = 0x02;
        public const int SI_GPIO_2 = 0x04;
        public const int SI_GPIO_3 = 0x08;

        // GetDeviceVersion() return codes
        public const int SI_CP2101_VERSION = 0x01;
        public const int SI_CP2102_VERSION = 0x02;
        public const int SI_CP2103_VERSION = 0x03;

        public static int Status;
        public static uint HUSBDevice;

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_GetNumDevices(
            ref int lpdwNumDevices);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_GetProductString(
            int dwDeviceNum,
            StringBuilder lpvDeviceString,
            int dwFlags);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_Open(
            int dwDevice,
            ref uint cyHandle);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_Close(
            uint cyHandle);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_Read(
            uint cyHandle,
            ref byte lpBuffer,
            int dwBytesToRead,
            ref int lpdwBytesReturned,
            int lpOverlapped);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_Write(
            uint cyHandle,
            ref byte lpBuffer,
            int dwBytesToWrite,
            ref int lpdwBytesWritten,
            int lpOverlapped);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_FlushBuffers(
            uint cyHandle,
            int FlushTransmit,
            int FlushReceive);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_SetTimeouts(
            int dwReadTimeout,
            int dwWriteTimeout);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_GetTimeouts(
            ref int dwReadTimeout,
            ref int dwWriteTimeout);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_CheckRXQueue(
            uint cyHandle,
            ref uint lpdwNumBytesInQueue,
            ref uint lpdwQueueStatus);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_SetBaudRate(
            uint cyHandle,
            int dwBaudRate);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_SetLineControl(
            uint cyHandle,
            int wLineControl);

        [DllImport("SiUSBXp.dll")]
        public static extern int SI_SetFlowControl(
            uint cyHandle,
            int bCTS_MaskCode,
            int bRTS_MaskCode,
            int bDTR_MaskCode,
            int bDSR_MaskCode,
            int bDCD_MaskCode,
            int bFlowXonXoff);
    }
}